//+------------------------------------------------------------------+
//|                                                   3LineBreak.mq4 |
//|                               Copyright  2004, Poul_Trade_Forum |
//|                                                         Aborigen |
//|                                          http://forex.kbpauk.ru/ |
//+------------------------------------------------------------------+
#property copyright "Poul Trade Forum"
#property link      "http://forex.kbpauk.ru/"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2

//---- input parameters
extern int Lines_Break=3;//******************
//---- buffers
double HighBuffer[];
double LowBuffer[];
double Swing[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   string short_name;
   IndicatorBuffers(3);
   SetIndexBuffer(0,HighBuffer);
   SetIndexBuffer(1,LowBuffer);
   SetIndexBuffer(2,Swing);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);

   short_name="3LineBreak";
      IndicatorShortName(short_name);
      SetIndexLabel(0,short_name);
      SetIndexLabel(1,short_name);
      SetIndexDrawBegin(0,10);
      SetIndexDrawBegin(1,10);
   return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

for (int shift=limit; shift>=0;shift--)
{
   if (shift==Bars-1) { Swing[shift]=1; continue; }
      double OLDSwing=Swing[shift+1];
         Swing[shift]= Swing[shift+1];

         double VALUE1=High[Highest(NULL,0,MODE_HIGH,Lines_Break,shift+1)];
         double VALUE2= Low[Lowest(NULL,0,MODE_LOW,Lines_Break,shift+1)];
            if (OLDSwing== 1 && Low[shift] <VALUE2) Swing[shift]=-1;
            if (OLDSwing==-1 && High[shift]>VALUE1) Swing[shift]= 1;

         HighBuffer[shift] = EMPTY_VALUE;
         LowBuffer[shift]  = EMPTY_VALUE;
         if (Swing[shift]== 1) { HighBuffer[shift]=High[shift]; LowBuffer[shift]=Low[shift]; }
         if (Swing[shift]==-1) { LowBuffer[shift]=High[shift]; HighBuffer[shift]=Low[shift]; }
         
      }
      return(0);
  }
//+------------------------------------------------------------------+

